#include <stdio.h>
#include <Windows.h>

int main(int argc, char *argv[])
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	BOOL ret;
	void *p;
	char dll_name[] = "hooks.dll";
	SIZE_T written;
	DWORD tid;
	HANDLE hThread;
	DWORD dwRet;

	memset(&si, 0, sizeof(si));

	ret = CreateProcess(NULL, argv[1], NULL, NULL, FALSE, CREATE_SUSPENDED, NULL, NULL, &si, &pi);
	if (!ret) {
		printf("CreateProcess failed: %d\n", GetLastError());
		return 1;
	}

	p = VirtualAllocEx(pi.hProcess, 0, sizeof(dll_name), MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
	if (!p) {
		printf("VirtualAllocEx failed: %d\n", GetLastError());
		return 1;
	}

	ret = WriteProcessMemory(pi.hProcess, p, dll_name, sizeof(dll_name), &written);
	if (!ret) {
		printf("WriteProcessMemory failed: %d\n", GetLastError());
		return 1;
	}

	hThread = CreateRemoteThread(pi.hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)LoadLibraryA, p, 0, &tid);
	if (hThread == NULL) {
		printf("CreateRemoteThread failed: %d\n", GetLastError());
		return 1;
	}

	dwRet = WaitForSingleObject(hThread, INFINITE);
	if (dwRet == WAIT_FAILED) {
		printf("WaitForSingleObject failed: %d\n", GetLastError());
		return 1;
	}

	GetExitCodeThread(hThread, &dwRet);

	CloseHandle(hThread);

	ResumeThread(pi.hThread);

	dwRet = WaitForSingleObject(pi.hProcess, INFINITE);
	if (GetExitCodeProcess(pi.hProcess, &dwRet) == FALSE) {
		printf("Get Exit Code PRocess failed: %d\n", GetLastError());
		return 1;
	}

	CloseHandle(pi.hProcess);

	return dwRet;
}
